import java.awt.*;
import java.awt.event.*;
import java.net.*;

import javax.swing.ImageIcon;

public class AdApplet extends java.applet.Applet implements Runnable, MouseListener {
    
    Thread animator;
    
    Dimension offDimension;
    Image offImage;
    Graphics offGraphics;
    
    Image bg, text;

    public void init() {
        bg = new ImageIcon(getClass().getResource("bg.jpg")).getImage();
        text = new ImageIcon(getClass().getResource("text.png")).getImage();
        
        addMouseListener(this);
    }

    public void start() {
        animator = new Thread(this);
        animator.start();
    }

    public void run() {
        long tm = System.currentTimeMillis();
        while (Thread.currentThread() == animator) {
            repaint();
            tm += 50;
            long delay = tm - System.currentTimeMillis();
            if (delay > 0)
                try {
                    Thread.sleep(delay);
                } catch (InterruptedException e) {
                    break;
                }
        }
    }

    
    public void stop() {
        animator = null;
        offImage = null;
        offGraphics = null;
    }

    
    public void update(Graphics g) {
        Dimension d = getSize();
        
        // Create the offscreen graphics context
        if ((offGraphics == null)
         || (d.width != offDimension.width)
         || (d.height != offDimension.height)) {
            offDimension = d;
            offImage = createImage(d.width, d.height);
            offGraphics = offImage.getGraphics();
        }

        // Erase the previous image
        offGraphics.setColor(getBackground());
        offGraphics.fillRect(0, 0, d.width, d.height);
        offGraphics.setColor(Color.black);

        // Paint the frame into the image
        paintFrame(offGraphics);

        // Paint the image onto the screen
        g.drawImage(offImage, 0, 0, null);
    }
    
    public void paint(Graphics g) {
        update(g);
    }
    
    public void paintFrame(Graphics g) {
        g.drawImage(bg, 0, 0, null);
        Graphics2D g2 = (Graphics2D) g.create();
        int x = (int) (System.currentTimeMillis() % 1000);
        g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, (x < 500 ? x : 1000 - x) / 500f) );
        g2.drawImage(text, 330, 93, null);
    }
    
    public void mouseClicked(MouseEvent e) {
        try {
            
            String target = String.format("http://%s/dvdsite/index.html",
//                    super.getDocumentBase().getHost()); // be nice
                    "thedarkknight.warnerbros.com");    // be "evil".
            
            getAppletContext().showDocument(new URL(target), "_self");
        } catch (MalformedURLException e1) {
        }
    }
    
    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }
}
