/*  jPicEdt, a picture editor for LaTeX.
    Copyright (C) 1999-2007  Sylvain Reynal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Sylvain Reynal
    Département de Physique
    Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
    6, avenue du Ponceau
    95014 CERGY CEDEX
    FRANCE

    Tel : 00 +33 130 736 245
    Fax : 00 +33 130 736 667
    e-mail : reynal@ensea.fr
    jPicEdt web page : http://www.jpicedt.org
*/

package jpicedt.format.input.eepic;

import jpicedt.format.input.latex.LaTeXParser;
import jpicedt.format.input.util.*;
import jpicedt.graphic.model.*;

/**
 *  \thinlines or \thicklines or (eepic) \Thicklines<p>
 * @author Sylvain Reynal
 * @since jpicedt 1.1
 * @version $Id: EepicLineThicknessExpression.java,v 1.5.2.1 2007/09/02 11:56:00 reynal Exp $
 * <p>
 */
public class EepicLineThicknessExpression extends AlternateExpression  implements ExpressionConstants,PicObjectConstants {

    private Pool pool;
    private double lineWidth;

    public EepicLineThicknessExpression(Pool pl){

		pool = pl;

		// \\thinlines
		add(new LiteralExpression("\\thinlines"){
			public void action(ParserEvent e){
				if (DEBUG) System.out.println(e);
				pool.getAttributeSet(LaTeXParser.KEY_ATTRIBUTES).setAttribute(LINE_WIDTH,new Double(0.15)); 
		}});
		// \\thicklines
		add(new LiteralExpression("\\thicklines"){
			public void action(ParserEvent e){
				if (DEBUG) System.out.println(e);
				pool.getAttributeSet(LaTeXParser.KEY_ATTRIBUTES).setAttribute(LINE_WIDTH,new Double(0.30)); 
		}});
		// \\Thicklines (eepic)
		add(new LiteralExpression("\\Thicklines"){
			public void action(ParserEvent e){
				if (DEBUG) System.out.println(e);
				pool.getAttributeSet(LaTeXParser.KEY_ATTRIBUTES).setAttribute(LINE_WIDTH,new Double(0.45)); 
		}});
	
	
    }
} // LineThicknessExpression
