/*
 EepicParser.java - July 24, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C)  Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.format.input.eepic;

import jpicedt.format.input.util.RootExpression;
import jpicedt.format.input.util.Pool;

import jpicedt.graphic.PicPoint;
import jpicedt.graphic.model.*;

import java.awt.Color;
import java.io.*;
import java.util.*;

/**
 * Grammar tree for the epic/eepic parser. Since most shared variables are held by the LaTeXParser, the 
 * latter is absolutely needed. 
 */
public class EepicParser extends RootExpression {

	
	/**
	 * Creates a new grammar tree for the Eepic format
	 */
	public EepicParser(Pool pool) {

		add(new EepicLineThicknessExpression(pool));
		add(new EepicPathCommand(pool));		// \\path(x1,y1)...(xN,yN)
		add(new EepicDrawlineCommand(pool));	// \\drawline[stretch](x1,y1)...(xN,yN)
	}

	/**
	 * reinit eepic/LaTeX related parameters
	 */
	public void reinit(){

		// add eepic specific initialization here
	}

}
