/*
 PicColorExpression.java - July 23, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C)  Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.format.input.latex;

import jpicedt.format.input.util.*;
import jpicedt.graphic.model.*;

import java.awt.Color;

/**
 * jPicEdt syntax (ie lines starting with a %)
 * color : filled/blacken/whiten/shade
 * @author Sylvain Reynal
 * @since jpicedt 1.3
 * @version $Id: PicColorExpression.java,v 1.6.2.1 2007/09/02 11:56:03 reynal Exp $
 *
 *
 */
public class PicColorExpression extends AlternateExpression  implements ExpressionConstants, PicObjectConstants {

    private Pool pool;

    public PicColorExpression(Pool pl){ 
		pool = pl;
		add(new LiteralExpression("filled"){ // old jPicEdt 1.1 format
			public void action(ParserEvent e){
				if (DEBUG) System.out.println(e);
				pool.currentObj.setAttribute(FILL_COLOR,Color.black); 
				pool.currentObj.setAttribute(FILL_STYLE,SOLID); 
		}});

		add(new LiteralExpression("blacken"){
			public void action(ParserEvent e){
				if (DEBUG) System.out.println(e);
				pool.currentObj.setAttribute(FILL_COLOR,Color.black); 
				pool.currentObj.setAttribute(FILL_STYLE,SOLID); 
		}});

		add(new LiteralExpression("whiten"){
			public void action(ParserEvent e){
				if (DEBUG) System.out.println(e);
				pool.currentObj.setAttribute(FILL_COLOR,Color.white); 
				pool.currentObj.setAttribute(FILL_STYLE,SOLID); 
		}});

		add(new LiteralExpression("shade"){
			public void action(ParserEvent e){
				if (DEBUG) System.out.println(e);
				pool.currentObj.setAttribute(FILL_COLOR,Color.gray); 
				pool.currentObj.setAttribute(FILL_STYLE,SOLID); 
		}});
    }
}

