/*
 StarExpression.java - March 28, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C)  Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.format.input.pstricks;

import jpicedt.format.input.util.*;
import jpicedt.graphic.model.*;

/**
 * Handles (usually optional) "*" after \\psframebox,\\pspolygon,... by setting FILL_STYLE to SOLID.
 * <p>
 * Note : this expression is NOT implemented as an OptionalExpression !
 * @author Sylvain Reynal
 * @version $Id: StarExpression.java,v 1.4.2.1 2007/09/02 11:56:12 reynal Exp $ 
 */
public class StarExpression extends LiteralExpression  implements ExpressionConstants, PicObjectConstants {
		
	private Pool pl;
	
	public StarExpression(Pool pl){
			super("*");
			this.pl = pl;
	}
	
	public void action(ParserEvent e){
		if (DEBUG) System.out.println(e);
		pl.currentObj.setAttribute(FILL_STYLE,SOLID);
	}
}
