/*
 ExpressionConstants.java - 2001 - jPicEdt, a picture editor for LaTeX.
 Copyright (C)  Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.format.input.util;

/** 
 * Constants used by subclasses of AbstractRegularExpression.
 * @since jpicedt 1.3
 * @author Sylvain Reynal
 * @version $Id: ExpressionConstants.java,v 1.7.2.1 2007/09/02 11:56:13 reynal Exp $
 *
 */
public interface ExpressionConstants {

    /** debug flag ; turn on for verbose parsing */
    public static final boolean DEBUG=false;

	/** type for NumericalExpression */
    public static final int INTEGER=0;
	/** type for NumericalExpression */
    public static final int DOUBLE=1;

	/** sign for NumericalExpression */
    public static final int ANY_SIGN=0;
	/** sign for NumericalExpression */
    public static final int POSITIVE=1;
	/** sign for NumericalExpression */
    public static final int NEGATIVE=2;
	/** sign for NumericalExpression */
    public static final int STRICTLY_POSITIVE=3;
	/** sign for NumericalExpression */
    public static final int STRICTLY_NEGATIVE=4;
	/** sign for NumericalExpression */
    public static final int NON_NULL=5;

    /** RepeatExpression mode */
    public static final int EXACTLY=0;
    /** RepeatExpression mode */
    public static final int AT_LEAST=1;
    /** RepeatExpression mode */
    public static final int AT_MOST=2;

    /** constant for WildCharExpression */
    public static final int ANY_CHAR=0; // excluding EOL
    /** constant for WildCharExpression */
    public static final int ANY_CHAR_EOL=-2; // including EOL
    /** constant for WildCharExpression */
    public static final int EOL=-1;
	
	/** placeholder for WildSpaces expression (which is used pretty often) */
	public static final WhiteSpaces WHITE_SPACES = new WhiteSpaces();
	/** placeholder for WildSpacesOrEOL expression (which is used pretty often) */
	public static final WhiteSpacesOrEOL WHITE_SPACES_OR_EOL = new WhiteSpacesOrEOL();
} 
