/*  jPicEdt, a picture editor for LaTeX.
    Copyright (C) 1999-2007  Sylvain Reynal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Sylvain Reynal
    Département de Physique
    Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
    6, avenue du Ponceau
    95014 CERGY CEDEX
    FRANCE

    Tel : 00 +33 130 736 245
    Fax : 00 +33 130 736 667
    e-mail : reynal@ensea.fr
    jPicEdt web page : http://www.jpicedt.org
*/

package jpicedt.format.input.util;

/**
 * Any string (but w/o line-feeds !)<p>
 * Store the parsed string in Pool's string "notParsed".
 * @since jpicedt 1.3
 * @author Sylvain Reynal
 * @version $Id: NotParsableExpression.java,v 1.4.2.1 2007/09/02 11:56:13 reynal Exp $
 *
 */
public class NotParsableExpression extends RepeatExpression {

	private Pool pool;

	public NotParsableExpression(Pool pl){

		super(null,0,AT_LEAST);
		pool = pl;
				
		setPattern(new WildCharExpression(ANY_CHAR){
			public void action(ParserEvent e){
				if (DEBUG) System.out.println(e);
				Character C = getCharacter();
				if (C != null) pool.notParsed.append(C);}});
	}

	public void action(ParserEvent e){
		if (DEBUG) System.out.println(e);
		int counter = ((Integer)e.getValue()).intValue();
		// separate each line in "notParsed" with a CR if not an empty line :
		if (counter >0) pool.notParsed.append("\n");
	}
}

