/*
 EepicConstants.java - March 1, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://trashx.ensea.fr/jpicedt/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
package jpicedt.format.output.eepic;

/**
 * Constants useful for Eepic formatters 
 */
public interface EepicConstants extends jpicedt.format.output.latex.LatexConstants {
	
	//////////////////////////////
	// PROPERTIES NAMES
	/////////////////////////////

	public static final String KEY_THIN_LINES_MAXWIDTH = "eepic.thinlines";
	public static final String KEY_THICK_LINES_MAXWIDTH = "eepic.thicklines";
	public static final String KEY_FILE_WRAPPER_PROLOG = "eepic.file-wrapper-prolog";
	public static final String KEY_FILE_WRAPPER_EPILOG = "eepic.file-wrapper-epilog";

	////////////////////////////////
	//// DEFAULT VALUES
	////////////////////////////////	
	/** all lines with a thickness .lt. thinLinesDEFAULT are formatted as "thinlines" */
    public static final double DEFAULT_THIN_LINES_MAX_WIDTH = 0.151; 
	// 0.151 instead of 0.15 due to annoying rounding errors with some JVM...
	// e.g. sometimes, I get 0.150000000002 instead of 0.15, because java.lang.Math doesn't work with BigDecimal (instead, it relies on native C-lib)
	
	/** all lines with a thickness .lt. thickLinesDEFAULT but greater than thinLinesDEFAULT
	 * are formatted as "thicklines" ; other are formatted as "Thicklines" (case-sensitive !) */
    public static final double DEFAULT_THICK_LINES_MAX_WIDTH = 0.301;

	public static final String DEFAULT_FILE_WRAPPER_PROLOG = 
		"\\documentclass{article} "+CR_LF+"\\usepackage{epic,eepic} "+CR_LF+ "\\thispagestyle{empty}" + CR_LF+"\\begin{document}"+CR_LF+"";
	public static final String DEFAULT_FILE_WRAPPER_EPILOG = "\\end{document}";

	
}
