/*
 PstricksConstants.java - March 1, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
package jpicedt.format.output.pstricks;

import jpicedt.graphic.model.Arrow;
import java.awt.*;

/**
 * Useful constants used across the jpicedt.format.output.pstricks package. 
 * @author Sylvain Reynal
 * @version $Id: PstricksConstants.java,v 1.10.2.1 2007/09/02 11:55:14 reynal Exp $ 
 */
public interface PstricksConstants {
	
	/**
	 * Line separator for the current platform (i.e. "\n" on Unix, "\n\r" on Windows, "\r" on Mac,..)
	 */
	public static final String CR_LF = System.getProperty("line.separator");
	
	public static final String KEY_FILE_WRAPPER_PROLOG = "pstricks.file-wrapper-prolog";
	public static final String KEY_FILE_WRAPPER_EPILOG = "pstricks.file-wrapper-epilog";
	//public static final String KEY_USE_PS_ELLIPTIC_ARC_COMMAND = "pstricks.use-ps-elliptic-arc-command";
	
	/*public static final String DEFAULT_FILE_WRAPPER_PROLOG_ELLIPTICSTY = 
		"\\documentclass{article} "+CR_LF
		+"\\usepackage{pst-all,pstricks-add} "+CR_LF
		+"% Please copy both jpicedt-install-dir/add-ons/TeX-macros/pstricks-add.sty" + CR_LF
		+"% and pstricks-add.tex to your TeX install path !" + CR_LF
		+ "\\thispagestyle{empty}" + CR_LF
		+"\\begin{document} "+CR_LF;
		*/
	//public static final String DEFAULT_FILE_WRAPPER_PROLOG_PSTPLOTSTY =
	public static final String DEFAULT_FILE_WRAPPER_PROLOG =
		"\\documentclass{article} "+CR_LF+"\\usepackage{pst-all} "+CR_LF+ "\\thispagestyle{empty}" + CR_LF+"\\begin{document} "+CR_LF;
	public static final String DEFAULT_FILE_WRAPPER_EPILOG = "\\end{document}";
	//public static final String DEFAULT_USE_PS_ELLIPTIC_ARC_COMMAND = Boolean.TRUE.toString();

	public static final String RESCALING_TEX_FUNCTION = "\\JPicScale";

    
	/**
	 * colours natively supported by PsTricks
	 */
	Color PST_COLORS[] = {
	            Color.black,
	            Color.darkGray,
	            Color.gray,
	            Color.lightGray,
	            Color.white,
	            Color.red,
	            Color.green,
	            Color.blue,
	            Color.cyan,
	            Color.magenta,
	            Color.yellow};

	/**
	 * associate colours name  in the PsTricks syntax (cf. PsTricks's doc p.4)
	 */
	String PST_COLORNAMES[]={
	            "black",
	            "darkgray",
	            "gray",
	            "lightgray",
	            "white",
	            "red",
	            "green",
	            "blue",
	            "cyan",
	            "magenta",
	            "yellow"};
				
	/** PsTricks supported Arrow's */			
	Arrow[] PST_ARROWS = {
	            Arrow.NONE,
	            Arrow.ARROW_HEAD,
	            Arrow.REVERSE_ARROW_HEAD,
	            Arrow.DOUBLE_ARROW_HEAD,
	            Arrow.DOUBLE_REVERSE_ARROW_HEAD,
	            Arrow.T_BAR_CENTERED,
	            Arrow.T_BAR_FLUSHED,
	            Arrow.SQUARE_BRACKET,
	            Arrow.ROUNDED_BRACKET,
	            Arrow.CIRCLE_FLUSHED,
	            Arrow.CIRCLE_CENTERED,
	            Arrow.DISK_FLUSHED,
	            Arrow.DISK_CENTERED};
				
	/** Formatted string for a left arrow */			
	String[] PST_ARROWS_LEFT = {
		"",
		"<",
		">",
		"<<",
		">>",
		"|*",
		"|",
		"[",
		"(",
		"oo",
		"o",
		"**",
		"*"};

	/** Formatted string for a right arrow */			
	String[] PST_ARROWS_RIGHT = {
		"",
		">",
		"<",
		">>",
		"<<",
		"|*",
		"|",
		"]",
		")",
		"oo",
		"o",
		"**",
		"*"};

}
