/*
 Parser.java - July 30, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.graphic.io.parser;

import jpicedt.graphic.model.Drawing;

import java.io.*;

/**
 * This is the interface from which every parser passed as a parameter to "PECanvas.read()" (or similar
 * methods from related classes) must inherit.
 */
public interface Parser {
	
	/**
	 * kicks off the parsing process
	 * @return a new instance of a Drawing populated from the content of the given reader
	 * @throws ParserException when a parsing error was encountered, e.g. syntax error, block mismatch,...
	 */
	public Drawing parse(Reader reader) throws ParserException;
	
}
