/*
 EditPointConstraint.java - August 19, 2003 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.graphic.model;

/**
 * So far, this is just a tagging interface for constraints passed to Element.setPoint() methods.
 * This might be readily extended in the near future. 
 * @since jPicEdt 1.4
 * @author $Author: reynal $
 * @version $Id: EditPointConstraint.java,v 1.4.2.1 2007/09/02 11:56:26 reynal Exp $
 */
public interface EditPointConstraint  {
	
	/**
	 * Returns true if this constraint imposes the given constraint. This is useful for constraints which
	 * may contain several AND'd constraints at once.
	 */
	boolean imposes(EditPointConstraint c);

}  

