/*
 EditPointConstraintCollator.java - August 19, 2003 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.graphic.model;

import java.util.*;

/**
 * Collates several constraints together, ensuring there is no duplicate constraints.
 * @since jPicEdt 1.3.3
 * @author $Author: reynal $
 * @version $Id: EditPointConstraintCollator.java,v 1.3.2.1 2007/09/02 11:56:26 reynal Exp $
 */
// [SR:pending] code doc
public class EditPointConstraintCollator extends HashSet implements EditPointConstraint {

	public EditPointConstraintCollator(){
	}
	
	public EditPointConstraintCollator(EditPointConstraint c){
		if (c instanceof EditPointConstraintCollator) addAll((EditPointConstraintCollator)c);
		else add(c);
	}
	
	public EditPointConstraintCollator(EditPointConstraint c1, EditPointConstraint c2){
		add(c1);
		add(c2);
	}
	
	public EditPointConstraint and(EditPointConstraint c){
		if (c instanceof EditPointConstraintCollator) addAll((EditPointConstraintCollator)c);
		else add(c);
		return this;
	}
	
	public String toString(){
		StringBuffer buf = new StringBuffer();
		for (Iterator it = this.iterator(); it.hasNext();){
			buf.append(it.next().toString());
			buf.append(" & ");
		}
		return buf.toString();
	}
	
	public boolean imposes(EditPointConstraint c){
		if (c instanceof EditPointConstraintCollator) return containsAll((EditPointConstraintCollator)c);
		else return contains(c);
	}
	
			
} // class 

