/*
 ViewFactory.java - February 9, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.graphic.view;

import jpicedt.graphic.model.Element;


/**
 * A factory to create a View for a given Element. This is intented to enable customization according
 * e.g. to the given content-type (LaTeX, PsTricks, Eepic,...) when views differ (for example, PsTricks allows
 * colour-filled polygon whereas LaTeX doesn't).  
 * @since jPicEdt 1.3.2
 * @author Sylvain Reynal
 * @version $Id: ViewFactory.java,v 1.5.2.1 2007/09/02 11:56:29 reynal Exp $
 *
 */
public interface ViewFactory  {

	/**
	 * @return a View for the given Element
	 */
	View createView(Element element);
	
} // interface 

