package se.kth.bankingwebapp;

import static se.kth.bankingwebapp.DatabaseManager.DB;

import java.io.*;

import javax.servlet.ServletException;
import javax.servlet.http.*;

import winstone.WinstoneRequest;

public class AccountHolders extends HttpServlet {

    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        PrintWriter out = resp.getWriter();
        printPage(req, out, "", null);
    }
    
    
    protected void doPost(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        
        String msg = null;
        
        // FIXME:
        boolean isAdmin = ((WinstoneRequest) req).isUserInRole("administrator");
        
        String cmd = Util.getParam(req, "cmd");
        if (cmd.equals("add")) {
            if (isAdmin) {
                String newname = Util.getParam(req, "newname");
                String newpass = Util.getParam(req, "newpass");
                msg = DB.addUser(newname, newpass);
            } else {
                msg = "Only administrators may add account holders";
            }
        }
        
        
        if (cmd.equals("remove")) {
            try {
                int userId = Integer.parseInt(Util.getParam(req, "userId"));
                msg = DB.removeUser(userId);
            } catch (NumberFormatException nfe) {
                msg = "Bad number format.";
            }
        }
        
        printPage(req, resp.getWriter(), Util.getParam(req, "q"), msg);
    }
    
    
    private void printPage(HttpServletRequest req, PrintWriter os, String filter, String msg) throws IOException {
        
        String name = req.getRemoteUser();
        
        os.println("<html>");
        os.println("<head><link rel=stylesheet href='../style.css' type='text/css' /></head>");
        os.println("<h1>Administration</h1>");
        os.println("<p>Welcome " + name + ".</p>");
        os.printf("<p>Your roles: %s</p>", getRoles((WinstoneRequest) req));
        
        os.println("<h2>Account Holders</h2>");
        os.println("<center>");
        os.println("<table id='accounttbl'>");
        os.println("<tr class='header'><th>Account Holder</th>" +
                   "<th style='text-align: right;'>Balance</th><th /></tr>");
        for (int userId : DB.getAccountHolderIds()) {
            String userName = DB.getUserName(userId);
            if (!userName.contains(filter))
                continue;
            os.println("<form action='accountholders' method='post'>");
            os.printf("<input type='hidden' name='userId' value='%d'>%n", userId);
            os.printf("<tr><td>%s</td><td style='text-align: right;'>%s</td>%n",
                    userName, Util.formatCurrency(DB.getBalance(userId)));
            os.println("<td nowrap>&nbsp;&nbsp;<input type='submit' name='cmd' value='remove'/></td></tr>");
            os.println("</form>");
        }
        os.println("<form action='accountholders' method='post'>");
        os.printf("<tr><td>" +
                  "<input type=text name='newname' value='enter name' style='width: 45%%'/>" +
                  "<input type=password name='newpass' value='password' style='width: 45%%'/></td>" +
                  "<td style='text-align: right;'>%s</td>" +
                  "<td nowrap>&nbsp;&nbsp;<input type='submit' name='cmd' value='add'/></td>" +
                  "</form></tr>", Util.formatCurrency(0));
        os.println("</table>");
        
        if (msg != null)
            os.print("<div class='msg'>" + msg + "</div>");
        
        os.println("</center>");
        
        os.println("<h2>Search</h2>");
        os.println("<center>");
        os.println("<form action='accountholders' method='post'>");
        os.println("Account holder: <input type=text name='q'/> <input type=submit name='cmd' value='search'/>&nbsp&nbsp;<a href='accountholders'>clear</a>");
        os.println("</form>");
        os.println("</center>");
        
        os.println("<hr />");
        os.println("<div style='float: right;'>Logged in as <b>" + name + "</b>");
        os.println("</div></form>");
        
        os.println("</html>");
    }
    
    // FIXME:
    private String getRoles(WinstoneRequest req) {
        String roles = "";
                for (String role : new String[] { "administrator", "secretary" })
            if (req.isUserInRole(role))
                roles += (roles.length() > 0 ? "," : "") + role;
        return roles;
    }
}
