package se.kth.bankingwebapp;

import java.io.IOException;
import java.security.Permission;
import java.util.*;

public class BankingServer {
    
    @SuppressWarnings("unused")
    private static winstone.Launcher winstoneLauncher;
    
    private static class NoExitSecurityManager extends SecurityManager {
        
        @Override
        public void checkPermission(Permission perm) {
            // allow anything.
        }
        
        @Override
        public void checkPermission(Permission perm, Object context) {
            // allow anything.
        }
        
        @Override
        public void checkExit(int status) {
            super.checkExit(status);
            throw new SecurityException("Application tried to exit with " +
                    "code " + status);
        }
    }
    
    
    public static void main(String[] args) {
        
        System.setSecurityManager(new NoExitSecurityManager());
        
        try {
            DatabaseManager.DB.init();
        } catch (Exception e) {
            System.err.println("Could not initialize database: " + e);
            e.printStackTrace();
            return;
        }
        
        try {
            
            Map<String, String> wargs = new HashMap<String, String>();
            wargs.put("webroot", "webroot");
            wargs.put("httpPort", "8000"); // will default to 8080
            
            wargs.put("argumentsRealm.passwd.admin", "pass");
            wargs.put("argumentsRealm.roles.admin", "administrator,secretary");
            
            wargs.put("argumentsRealm.passwd.johndoe", "john");
            wargs.put("argumentsRealm.roles.johndoe", "secretary");
            
            wargs.put("logfile", "winstone_log.txt");
            winstone.Launcher.initLogger(wargs);
            winstoneLauncher = new winstone.Launcher(wargs);
        } catch (IOException ioe) {
            ioe.printStackTrace();
        }
    }
}
