package se.kth.bankingwebapp;

import java.io.IOException;

import javax.servlet.*;
import javax.servlet.http.*;
import static se.kth.bankingwebapp.DatabaseManager.DB;

public class LoginServlet extends HttpServlet {

    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        
        ServletOutputStream os = resp.getOutputStream();
        
        os.print("<html><head><link rel=stylesheet href='style.css' type='text/css' /></head><body>");
        os.print("<form action='login' method='post'>");
        
        HttpSession session = req.getSession();
        Integer loginId = session != null ?
                (Integer) session.getAttribute("loginId") : null;
        
        if (loginId != null) {
            String name = DB.getUserName((int) loginId);
            os.print("Logged in as <b>" + name + "</b>");
            os.print("<form action='login' method='post'>");
            os.print(" <input type='submit' value='logout' name='cmd' />");
        } else {
            os.print("<table>");
            os.print("<tr><td>Username:</td><td><input name='name' type='text' /></td></tr>");
            os.print("<tr><td>Password:</td><td><input name='pass' type='password' /></td></tr>");
            os.print("<tr><td /><td><input type='submit' name='cmd' value='login' /></td></tr>");
            os.print("</table>");
        }
        
        os.print("</form></body></html>");
    }
    
    
    protected void doPost(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        
        String cmd  = getParam(req, "cmd");
        
        ServletOutputStream os = resp.getOutputStream();
        
        os.print("<html>");
        if (cmd.equals("login"))
            doLogin(req, os);
        else if (cmd.equals("logout"))
            doLogout(req, os);
        os.print("</html>");
    }


    private void doLogin(HttpServletRequest req, ServletOutputStream os)
            throws IOException {
        String name = getParam(req, "name");
        String pass = getParam(req, "pass");
        
        if (DB.isUserPassValid(name, pass)) {
            int userId = DB.getUserId(name);
            req.getSession().setAttribute("loginId", userId);
            os.print("<head>");
            os.print("<meta http-equiv='refresh' content='2;url=accounts' />");
            os.print("<link rel=stylesheet href='style.css' type='text/css' />");
            os.print("</head><body>");
            os.print("<div class='msg'>Login successful. Redirecting to <a href='accounts'>accounts</a> overview.</div>");
            os.print("</body>");
        } else {
            os.print("<body>Access denied. <a href='login'>Try again.</a></body>");
        }
    }
    
    private void doLogout(HttpServletRequest req, ServletOutputStream os)
    throws IOException {
        
        req.getSession().removeAttribute("loginId");
        req.getSession().invalidate();
        
        os.print("<head>");
        os.print("<meta http-equiv='refresh' content='2;url=login' />");
        os.print("<link rel=stylesheet href='style.css' type='text/css' />");
        os.print("</head><body>");
        os.print("<div class='msg'>Logged out. Redirecting to login page.</div>");
        os.print("</body>");
    }
    
    
    private String getParam(HttpServletRequest req, String param) {
        String[] vals = req.getParameterValues(param);
        return vals == null || vals.length == 0 ? "" : vals[0];
    }
}
