/*
 PicDashStatement.java - July 23, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C)  Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package jpicedt.format.input.latex;

import jpicedt.format.input.util.*;
import jpicedt.graphic.model.*;

/**
 * Handles dash statements in jPicEdt-syntax (ie TeX-like comments)
 * % ... dash= ...
 * @author Sylvain Reynal
 * @since jpicedt 1.3
 * @version $Id: PicDashStatement.java,v 1.6.2.1 2007/09/02 11:56:03 reynal Exp $
 *
 */
public class PicDashStatement extends StatementExpression  implements ExpressionConstants, PicObjectConstants {

    private Pool pool;

    public PicDashStatement(Pool pl){
		super("dash", "=", null, DOUBLE, POSITIVE); // no postfix
		pool = pl;
    } 

    public void action(ParserEvent e){

		if (DEBUG) System.out.println(e); 
		double dash = ((Double)e.getValue()).doubleValue();
		if (dash > 0){
			pool.currentObj.setAttribute(DASH_OPAQUE,(Double)(e.getValue()));
			pool.currentObj.setAttribute(DASH_TRANSPARENT, (Double)(e.getValue()));
			pool.currentObj.setAttribute(LINE_STYLE,DASHED);
		}
    }
}
