/*  jPicEdt, a picture editor for LaTeX.
    Copyright (C) 1999-2007  Sylvain Reynal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Sylvain Reynal
    Département de Physique
    Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
    6, avenue du Ponceau
    95014 CERGY CEDEX
    FRANCE

    Tel : 00 +33 130 736 245
    Fax : 00 +33 130 736 667
    e-mail : reynal@ensea.fr
    jPicEdt web page : http://www.jpicedt.org
*/

package jpicedt.format.input.pstricks;

import jpicedt.format.input.util.*;
import jpicedt.graphic.model.*;
import jpicedt.graphic.PicPoint;

/**
 * Quick line :
 * <b>\\qline(x0,y0)(x1,y1)</B>
 * <p>
 * Uses default parameters values.
 * @author Sylvain Reynal
 * @version $Id: PsQLineExpression.java,v 1.5.2.1 2007/09/02 11:56:12 reynal Exp $ 
 */
public class PsQLineExpression extends SequenceExpression {

	private Pool pool;

	public PsQLineExpression(Pool pl){

		super(true); // throw IncompleteSequence Exception
		pool = pl;

		PicMultiCurve prototype = new PicMultiCurve(new PicPoint(),new PicPoint());

		add(new PSTInstanciationExpression("\\qline", prototype,pool));
		add(WHITE_SPACES_OR_EOL);
		add(new PSTPicPointExpression(0,pool)); // set first end-point
		add(WHITE_SPACES_OR_EOL);
		add(new PSTPicPointExpression(3,pool)); // set last end-point (control-points move so as to leave segment straight)
	}
	public String toString(){
		return "[PsQLineExpression]";
	}
}
