/*
 PstricksViewFactory.java - February 9, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://trashx.ensea.fr/jpicedt/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.format.output.pstricks;

import jpicedt.graphic.model.*;
import jpicedt.graphic.event.*;
import jpicedt.graphic.PicPoint;
import jpicedt.graphic.view.*;

import java.awt.*;
import java.awt.geom.*;

/**
 * A factory to create a View for a given Element when the underlying content type for
 * the model is Pstricks.
 * @since jPicEdt 1.3
 * @author Sylvain Reynal
 * @version $Id: PstricksViewFactory.java,v 1.7.2.1 2007/09/02 11:55:14 reynal Exp $ 
 *
 */
public class PstricksViewFactory extends DefaultViewFactory {

	/**
	 * @return a View for the given Element
	 */
	public View createView(Element element){
		// [SR:en_cours] if (element instanceof PicEllipse) return new PstricksViewFactory.EllipseView((PicEllipse)element);
		// add Pstricks specific View's here
		// [SR:en_cours] else return super.createView(element);
		return super.createView(element);
	}
	
	//////////////////////////////////////////////////////////////////////////
	//// ELLIPSE VIEW
	//////////////////////////////////////////////////////////////////////////
	// [SR:en_cours] 
	// /**
	//  * a View to render PicEllipse ; overriden from DefaultViewFactory so that we don't paint
	//  * elliptic arcs, which are not supported by PsTricks (i.e. we paint them as ellipses)
	//  */
	// public class EllipseView extends DefaultViewFactory.EllipseView {

	// 	/**
	// 	 * construct a new View for the given PicEllipse
	// 	 */
	// 	public EllipseView(PicEllipse ellipse){
	// 		super(ellipse);
	// 	}

	// 	/**
	// 	 * Give notification from the model that a change occured for an element this view is responsible
	// 	 * for rendering.<p>
	// 	 */
	// 	public void changedUpdate(DrawingEvent.EventType eventType){
			// if geometry changed from ellipse to circle or vice-versa, we need to *force*
			// update of interior paint attribute ; otherwise, if attribute changed, 
			// no need to worry, for this is done automatically by superclass :
	// 		if (eventType!=DrawingEvent.EventType.ATTRIBUTE_CHANGE) syncAttributes(); 
	// 		super.changedUpdate(eventType); // super calls syncAttribute if ATTRIBUTE_CHANGE, it's ok.
	// 	}
		
	// 	/**
	// 	 * Synchronize the "shape" variable with the model ; current implementation paint
	// 	 * elliptic arcs as plain ellipses.
	// 	 */
	// 	protected void syncShape(){
			
	// 		super.syncShape();			
	// 		if (!((PicEllipse)element).isCircular()) { // elliptic arcs -> paint as ellipse
	// 			((Arc2D)shape).setAngleExtent(360);
	// 			arrowStart = arrowEnd = null; // hence don't paint arrow neither
	// 		}
	// 	}
	// }	
} // class

