/*
 PicGroupFormatter.java - 2001 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.format.output.util;

import jpicedt.graphic.model.PicGroup;
import jpicedt.graphic.model.Element;
import jpicedt.graphic.io.formatter.Formatter;
import jpicedt.graphic.io.formatter.FormatterFactory;

import java.util.*;

/**
 * A formatter for PicGroup objects. This implementation simply {@link #format} on each children in turn.
 * @author Sylvain Reynal
 * @since jpicedt 1.0
 * @version $Id: PicGroupFormatter.java,v 1.3.2.1 2007/09/02 11:55:14 reynal Exp $
 * <p>
 *
 */
public class PicGroupFormatter implements Formatter {

	private PicGroup group;
	private FormatterFactory factory;

	public PicGroupFormatter(PicGroup group, FormatterFactory factory){

		this.group = group;
		this.factory=factory;

	}

	/**
	 * @return a String representing this Element in the PsTricks 
	 */
	public String format(){

		StringBuffer buf = new StringBuffer(100);
		for(Iterator it=group.children(); it.hasNext();){
			Element obj =  (Element)it.next();
			buf.append(factory.createFormatter(obj).format());
		}
		return buf.toString();
	}
} // class PicGroupFormatter
