/*
 BasicEditPointConstraint.java - August 19, 2003 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org/
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.graphic.model;

/**
 * Default implementation of EditPointConstraint.
 * @since jPicEdt 1.3.3
 * @author $Author: reynal $
 * @version $Id: BasicEditPointConstraint.java,v 1.5.2.1 2007/09/02 11:56:26 reynal Exp $
 */
public class BasicEditPointConstraint implements EditPointConstraint  {

	private String displayName;
	
	/**
	 * Create a new constraint with the given name ; this maybe a help message for the GUI for instance.
	 */
	public BasicEditPointConstraint(String displayName){
		this.displayName = displayName;
	}
	
	/**
	 * Returns a new constraint made of this constraint AND'd with the given constraint.
	 */
	public EditPointConstraintCollator and(EditPointConstraint c){
		EditPointConstraintCollator col = new EditPointConstraintCollator();
		col.add(this);
		col.add(c);
		return col;
	}
	
	public boolean imposes(EditPointConstraint c){
		return c==this; // [SR:pending] c.equals(this) ? need check...
	}
	
	public String getDisplayName(){
		return displayName;
	}
	
	public String toString(){
		return displayName;
	}
	
} // class 

