/*
 ActionDispatcher.java - January 2, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.graphic.toolkit;

import jpicedt.graphic.PECanvas;


/**
 * Allow PEAction's to know upon which target they must act.<p> 
 * This allows PEAction's,<ul> 
 * <li> either to be shared across multiple PECanvas's in the context of
 * a MDI user interface (in which case the UI implementation should provide its own ActionDispatcher), 
 * <li> or to be attached permanently to a given PECanvas (use DefaultActionDispatcher for that)
 * </ul> 
 * @since jPicEdt
 * @author Sylvain Reynal
 */

public interface ActionDispatcher {
	
	/**
	 * return the PECanvas upon which a PEAction should act.<p>
	 * @since jPicEdt
	 * @author Sylvain Reynal
	 */
	public PECanvas getTarget();

} // interface 

