/*
 ActionFactory.java - February 27, 2002 - jPicEdt, a picture editor for LaTeX.
 Copyright (C) 1999-2007 Sylvain Reynal

 Département de Physique
 Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
 6, avenue du Ponceau
 F-95014 CERGY CEDEX

 Tel : +33 130 736 245
 Fax : +33 130 736 667
 e-mail : reynal@ensea.fr
 jPicEdt web page : http://www.jpicedt.org
  
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jpicedt.graphic.toolkit;

import javax.swing.Action;
import jpicedt.graphic.view.HitInfo;

/**
 * Allows an Element, in interaction with a PopupMenuFactory, to produce Action's that make sense
 * only with this Element.
 * @author Sylvain Reynal
 * @since jPicEdt 1.3.2
 * @version $Id: ActionFactory.java,v 1.6.2.1 2007/09/02 11:56:27 reynal Exp $
 */
public interface ActionFactory {

	/**
	 * Create an array of PEAction's related to the Element
	 * @param actionDispatcher dispatcher used to create a PEAction
	 * @param localizer used to localizer action parameters
	 * @param hi a HitInfo containing information related to the mouse-event which triggered the popup menu.
	 */
	public PEAction[] createActions(ActionDispatcher actionDispatcher, ActionLocalizer localizer, HitInfo hi);
}

