/*  jPicEdt, a picture editor for LaTeX.
    Copyright (C) 1999-2007  Sylvain Reynal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Sylvain Reynal
    Département de Physique
    Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
    6, avenue du Ponceau
    95014 CERGY CEDEX
    FRANCE

    Tel : 00 +33 130 736 245
    Fax : 00 +33 130 736 667
    e-mail : reynal@ensea.fr
    jPicEdt web page : http://www.jpicedt.org
*/

package jpicedt.ui.internal;

import jpicedt.JPicEdt;
import jpicedt.graphic.PECanvas;
import jpicedt.graphic.toolkit.EditorKit;
import jpicedt.ui.action.ActionRegistry;
import jpicedt.ui.util.RunExternalCommand;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.net.*;

/**
 * The main application toolbar.
 * @author Sylvain Reynal
 * @since PicEdt 1.0
 * @version $Id: PEToolBar.java,v 1.8.2.1 2007/09/02 11:56:30 reynal Exp $
 */
public class PEToolBar extends jpicedt.graphic.toolkit.PEToolBar {
	
	//private JLabel currentToolLbl = new JLabel(jpicedt.Localizer.currentLocalizer().get(EditorKit.SELECT+".tooltip"));


	public PEToolBar() {

		ActionRegistry actionRegistry = JPicEdt.getActionRegistry();
		this.setFloatable(false);
		this.setBorder(BorderFactory.createEtchedBorder());

		add(actionRegistry.getAction(JPicEdt.FileNewAction.KEY));
		add(actionRegistry.getAction(JPicEdt.FileOpenAction.KEY));
		add(actionRegistry.getAction(JPicEdt.FileSaveAction.KEY));
		add(actionRegistry.getAction(JPicEdt.FileReloadAction.KEY));
		add(actionRegistry.getAction(JPicEdt.ExitAction.KEY));
		addSeparator();
		add(actionRegistry.getAction(EditorKit.CopyAction.KEY));
		add(actionRegistry.getAction(EditorKit.CutAction.KEY));
		add(actionRegistry.getAction(EditorKit.PasteAction.KEY_PASTE));
		addSeparator();
		add(actionRegistry.getAction(JPicEdt.UndoAction.KEY));
		add(actionRegistry.getAction(JPicEdt.RedoAction.KEY));
		addSeparator();
		add(actionRegistry.getAction(JPicEdt.ToggleAttributesPanelAction.KEY));
		add(actionRegistry.getAction(JPicEdt.ToggleToolkitPanelAction.KEY)); 
		add(actionRegistry.getAction(JPicEdt.PreferencesAction.KEY));
		add(actionRegistry.getAction(JPicEdt.ShowHelpAction.KEY));
		addSeparator();
		add(actionRegistry.getAction(RunExternalCommand.LATEX));
		add(actionRegistry.getAction(RunExternalCommand.DVIVIEWER));
		add(actionRegistry.getAction(RunExternalCommand.DVIPS));
		add(actionRegistry.getAction(RunExternalCommand.GHOSTVIEW));
		// current tool :
		//addSeparator();
		//add(currentToolLbl);
		// remaining gap:
		add(Box.createGlue());
	}

	/**
	 * Implementation of PropertyChangeListener interface
	 * Allows this tool-bar to get notified of change from the target EditorKit
	 */
	public void updateCurrentTool(String mouseToolName){
		//currentToolLbl.setText(jpicedt.Localizer.currentLocalizer().get(mouseToolName+".tooltip"));
	}

} // classe PEToolBar
