/*  jPicEdt, a picture editor for LaTeX.
    Copyright (C) 1999-2007  Sylvain Reynal

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Sylvain Reynal
    Département de Physique
    Ecole Nationale Supérieure de l'Electronique et de ses Applications (ENSEA)
    6, avenue du Ponceau
    95014 CERGY CEDEX
    FRANCE

    Tel : 00 +33 130 736 245
    Fax : 00 +33 130 736 667
    e-mail : reynal@ensea.fr
    jPicEdt web page : http://trashx.ensea.fr/jpicedt/
*/

package jpicedt.widgets;

import javax.swing.*;
import java.awt.*;

/**
 * A customized cell-renderer for the Motif LAF (turns selected item background to white) 
 * @author Sylvain Reynal
 * @since jpicedt 1.2
 * @version $Id: MotifLAFCellRenderer.java,v 1.5.2.1 2007/09/02 11:56:31 reynal Exp $
 * <p>
 * @see javax.swing.JList
 */
public class MotifLAFCellRenderer extends JLabel implements ListCellRenderer {

	public MotifLAFCellRenderer() {
		setOpaque(true);
	}

	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
	{
		setBackground(isSelected ? Color.white : Color.lightGray);
		setIcon((ImageIcon)value);
		//setForeground(isSelected ? Color.white : Color.black);
		return this;
	}
}
